# Coveo SmartSnippet Component (CoveoSmartSnippet)

The SmartSnippet component displays the excerpt of a document that would be most likely to answer a particular query.

This excerpt can be visually customized using inline styling.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- alwaysOpenInNewWindow
- hrefTemplate
- maximumSnippetHeight
- titleField
- useIFrame

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### alwaysOpenInNewWindow

alwaysOpenInNewWindow: boolean

- Defined in ui/SmartSnippet/SmartSnippet.ts :147

Specifies whether the component should open its links in a new window instead of opening them in the current context.

Default value is `false`.

Default

  `false`

Markup configuration example(s) :

    data-always-open-in-new-window='true'
    data-always-open-in-new-window='false'

### hrefTemplate

hrefTemplate: string

- Defined in ui/SmartSnippet/SmartSnippet.ts :139

Specifies a template literal from which to generate the title and URI's `href` attribute value (see Template literals).

This option overrides the [`field`]{@link SmartSnippet.options.uriField} option value.

The template literal can reference any number of fields from the parent result. It can also reference global scope properties.

Examples:

- The following markup generates an `href` value such as `http://uri.com?id=itemTitle`:

    <a class='CoveoSmartSnippet' data-href-template='${clickUri}?id=${raw.title}'></a>

- The following markup generates an `href` value such as `localhost/fooBar`:

    <a class='CoveoSmartSnippet' data-href-template='${window.location.hostname}/{Foo.Bar}'></a>

Default value is `undefined`.

Markup configuration example(s) :

    data-href-template='foo'

### maximumSnippetHeight

maximumSnippetHeight: number

- Defined in ui/SmartSnippet/SmartSnippet.ts :107

The maximum height an answer can have in pixels. Any part of an answer exceeding this height will be hidden by default and expendable via a "show more" button. Default value is `250`.

Minimum

  `0`

Default

  `250`

Markup configuration example(s) :

    data-maximum-snippet-height='10'

### titleField

titleField: IFieldOption

- Defined in ui/SmartSnippet/SmartSnippet.ts :112

The field to display for the title.

Default

  `@title`

Markup configuration example(s) :

    data-title-field='@foo'

### useIFrame

useIFrame: boolean

- Defined in ui/SmartSnippet/SmartSnippet.ts :162

Specify if the SmartSnippet should be displayed inside an iframe or not.

Use this option in specific cases where your environment has limitations around iframe usage.

Examples:

    <div class='CoveoSmartSnippet' data-use-i-frame='true'></div>

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-use-i-frame='true'
    data-use-i-frame='false'

## Constructors

### constructor

- new SmartSnippet(element: HTMLElement, type: string, bindings?: IComponentBindings): SmartSnippet

- Inherited from Component.constructor

  - Defined in ui/Base/Component.ts :296

  Create a new Component. Resolve all IComponentBindings if not provided.
  Create a new Logger for this component. Attach the component to the SearchInterface.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to create the component. Used to bind data on the element.

  - ##### type: string

    The unique identifier for this component. See: IComponentDefinition.ID. Used to generate the unique Coveo CSS class associated with every component.

  - ##### Default value bindings: IComponentBindings = {}

    The environment for every component. Optional, but omitting to provide one will impact performance.

  #### Returns SmartSnippet